Automate installation of DXVK, D9VK + Wine/Wine Staging & update GPU drivers + PlayonLinux wineprefixes (Debian/Ubuntu/Mint/Arch Linux/Manjaro)
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

404 lines
11 KiB

5 years ago
5 years ago
2 years ago
2 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/env bash
  2. # DXVK/Wine-Staging scripts dispatcher for various Linux distributions
  3. # Copyright (C) 2019 Pekka Helenius
  4. #
  5. # This program is free software: you can redistribute it and/or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation, either version 3 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  17. ##############################################################################
  18. source options.conf
  19. ###########################################################
  20. # Check if we're using bash or sh to run the script. If bash, OK.
  21. # If another one, ask user to run the script with bash.
  22. BASH_CHECK=$(ps | grep `echo $$` | awk '{ print $4 }')
  23. if [ $BASH_CHECK != "bash" ]; then
  24. echo "
  25. Please run this script using bash (/usr/bin/bash).
  26. "
  27. exit 1
  28. fi
  29. ###########################################################
  30. # Just a title & author for this script, used in initialization and help page
  31. SCRIPT_TITLE="\e[1mWine/Wine Staging & DXVK package builder & auto-installer\e[0m"
  32. SCRIPT_AUTHOR="Pekka Helenius (~Fincer), 2019"
  33. ###########################################################
  34. # Allow interruption of the script at any time (Ctrl + C)
  35. trap "exit" INT
  36. ###########################################################
  37. COMMANDS=(
  38. curl
  39. date
  40. df
  41. find
  42. git
  43. grep
  44. groups
  45. nproc
  46. patch
  47. readlink
  48. sudo
  49. tar
  50. uname
  51. wc
  52. wget
  53. )
  54. SUDO_GROUPS=(
  55. sudo
  56. wheel
  57. )
  58. function checkCommands() {
  59. local COMMANDS_NOTFOUND
  60. local a
  61. if [[ $(which --help 2>/dev/null) ]] && [[ $(echo --help 2>/dev/null) ]]; then
  62. a=0
  63. for command in ${@}; do
  64. if [[ ! $(which $command 2>/dev/null) ]]; then
  65. COMMANDS_NOTFOUND[$a]=${command}
  66. let a++
  67. fi
  68. done
  69. if [[ -n $COMMANDS_NOTFOUND ]]; then
  70. echo -e "\nError! The following commands could not be found: ${COMMANDS_NOTFOUND[*]}\nAborting\n"
  71. exit 1
  72. fi
  73. else
  74. exit 1
  75. fi
  76. }
  77. checkCommands "${COMMANDS[*]}"
  78. ###########################################################
  79. # http://wiki.bash-hackers.org/snipplets/print_horizontal_line#a_line_across_the_entire_width_of_the_terminal
  80. function INFO_SEP() { printf '%*s\n' "${COLUMNS:-$(tput cols)}" '' | tr ' ' - ; }
  81. ###########################################################
  82. if [[ $(uname -a | grep -c x86_64) -eq 0 ]]; then
  83. echo "This script supports 64-bit architectures only."
  84. exit 1
  85. fi
  86. if [[ $(groups | grep -cE $(echo ${SUDO_GROUPS[*]} | sed 's/ /|/g')) -eq 0 ]]; then
  87. echo "You must belong to a sudo group (checked groups: ${SUDO_GROUPS[*]})."
  88. exit 1
  89. fi
  90. unset sudogrp
  91. if [[ $UID -eq 0 ]]; then
  92. echo "Run as a regular user."
  93. exit 1
  94. fi
  95. ###########################################################
  96. # User-passed arguments for the script
  97. # We check the values of this array
  98. # and pass them to the subscripts if supported
  99. i=0
  100. for arg in ${@}; do
  101. case ${arg} in
  102. --no-staging)
  103. # Do not build Wine staging version, just Wine
  104. ;;
  105. --no-install)
  106. # Just build, do not install DXVK or Wine-Staging
  107. # Note that some version of Wine is required for DXVK compilation, though!
  108. ;;
  109. --no-wine)
  110. # Skip Wine build & installation process all together
  111. NO_WINE=
  112. ;;
  113. --no-dxvk)
  114. # Skip DXVK build & installation process all together
  115. NO_DXVK=
  116. ;;
  117. --no-pol)
  118. # Skip PlayOnLinux Wine prefixes update process
  119. ;;
  120. *)
  121. echo -e "\n\
  122. \
  123. ${SCRIPT_TITLE} by ${SCRIPT_AUTHOR}\n\n\
  124. Usage:\n\nbash updatewine.sh\n\nArguments:\n\n\
  125. --no-install\tDo not install Wine or DXVK. Just compile them. Wine, meson & glslang must be installed for DXVK compilation.\n\
  126. --no-dxvk\tDo not compile or install DXVK\n\
  127. --no-pol\tDo not update PlayOnLinux Wine prefixes\n\n\
  128. --no-staging\tCompile Wine instead of Wine Staging\n\
  129. --no-wine\tDo not compile or install Wine/Wine Staging\n\n\
  130. Compiled packages are installed by default, unless '--no-install' argument is given.\n\
  131. If '--no-install' argument is given, the script doesn't check or update your PlayOnLinux Wine prefixes.\n"
  132. exit 0
  133. ;;
  134. esac
  135. args[$i]="${arg}"
  136. let i++
  137. done
  138. ###########################################################
  139. # Date timestamp and random number identifier for compiled
  140. # DXVK & Wine Staging builds
  141. # This variable is known as 'datedir' in other script files
  142. datesuffix=$(echo $(date '+%Y-%m-%d-%H%M%S'))
  143. ###########################################################
  144. # Add git commit hash overrides to argument list
  145. # Pass them to subscripts, as well.
  146. githash_overrides=(
  147. "${git_commithash_dxvk}" # 0
  148. "${git_commithash_glslang}" # 1
  149. "${git_commithash_meson}" # 2
  150. "${git_commithash_wine}" # 3
  151. )
  152. # Add git branches to argument list
  153. # Pass them to subscripts, as well.
  154. gitbranch_overrides=(
  155. "${git_branch_dxvk}" # 4
  156. "${git_branch_glslang}" # 5
  157. "${git_branch_meson}" # 6
  158. "${git_branch_wine}" # 7
  159. )
  160. # Add git sources to argument list
  161. # Pass them to subscripts, as well.
  162. gitsources=(
  163. "${git_source_dxvk}" # 8
  164. "${git_source_glslang}" # 9
  165. "${git_source_meson}" # 10
  166. "${git_source_wine}" # 11
  167. "${git_source_winestaging}" # 12
  168. )
  169. #############################
  170. # Commit syntax validity check
  171. for githash in ${githash_overrides[@]}; do
  172. if [[ ! $(printf ${githash} | wc -c) -eq 40 ]] && \
  173. [[ ! ${githash} == HEAD ]]; then
  174. echo -e "\nError: badly formatted commit hash '${githash}' in the script file 'updatewine.sh'. Aborting\n"
  175. exit 1
  176. fi
  177. done
  178. ###########################################################
  179. params=(${datesuffix} ${githash_overrides[@]} ${gitbranch_overrides[@]} ${gitsources[@]} ${args[@]})
  180. ###########################################################
  181. # General function for question responses
  182. function questionresponse() {
  183. local response=${1}
  184. read -r -p "" response
  185. if [[ $(echo $response | sed 's/ //g') =~ ^([yY][eE][sS]|[yY])$ ]]; then
  186. echo ""
  187. return 0
  188. else
  189. return 1
  190. fi
  191. }
  192. ###########################################################
  193. function reqsCheck() {
  194. local AVAIL_SPACE
  195. local REC_SPACE
  196. local MSG_SPACE
  197. local AVAIL_RAM
  198. local REC_RAM
  199. local MSG_RAM
  200. AVAIL_SPACE=$(df -h -B MB --output=avail . | sed '1d; s/[A-Z]*//g')
  201. REC_SPACE=8000
  202. MSG_SPACE="\e[1mWARNING:\e[0m Not sufficient storage space\n\nYou will possibly run out of space while compiling software.\n\
  203. The script strongly recommends ~\e[1m$((${REC_SPACE} / 1000)) GB\e[0m at least to compile software successfully but you have only\n\
  204. \e[1m${AVAIL_SPACE} MB\e[0m left on the filesystem the script is currently placed at.\n\n\
  205. Be aware that the script process may fail because of this, especially while compiling Wine Staging.\n\n\
  206. Do you really want to continue? [Y/n]"
  207. AVAIL_RAM=$(( $(grep -oP "(?<=^MemFree:).*[0-9]" /proc/meminfo | sed 's/ //g') / 1024 ))
  208. REC_RAM=4096
  209. MSG_RAM="\e[1mWARNING:\e[0m Not sufficient RAM available\n\nCompilation processes will likely fail.\n\
  210. The script strongly recommends ~\e[1m${REC_RAM} MB\e[0m at least to compile software successfully but you have only\n\
  211. \e[1m${AVAIL_RAM} MB\e[0m left on the computer the script is currently placed at.\n\n\
  212. Be aware that the script process may fail because of this, especially while compiling DXVK.\n\n\
  213. Do you really want to continue? [Y/n]"
  214. function reqs_property() {
  215. local avail_prop
  216. local req_prop
  217. local req_message
  218. local req_installtargets
  219. local req_targetconditions
  220. local fullcondition
  221. local i
  222. avail_prop="${1}"
  223. req_prop="${2}"
  224. req_message="${3}"
  225. req_installtargets="${4}"
  226. i=0
  227. for req_installtarget in ${req_installtargets}; do
  228. req_targetconditions[$i]=$(echo "[[ ! -v ${req_installtarget} ]] ||")
  229. let i++
  230. done
  231. req_targetconditions=($(echo ${req_targetconditions[@]} | sed 's/\(.*\) ||/\1 /'))
  232. fullcondition="[[ "${avail_prop}" -lt "${req_prop}" ]] && ($(echo ${req_targetconditions[@]}))"
  233. if $(eval ${fullcondition}); then
  234. INFO_SEP
  235. echo -e "${req_message}"
  236. questionresponse
  237. if [[ $? -ne 0 ]]; then
  238. echo -e "Cancelling.\n"
  239. exit 1
  240. fi
  241. unset avail_prop req_prop req_installtarget req_targetconditions fullcondition
  242. fi
  243. }
  244. reqs_property "${AVAIL_SPACE}" "${REC_SPACE}" "${MSG_SPACE}" "NO_WINE"
  245. reqs_property "${AVAIL_RAM}" "${REC_RAM}" "${MSG_RAM}" "NO_DXVK"
  246. }
  247. ###########################################################
  248. function sudoQuestion() {
  249. sudo -k
  250. echo -e "\e[1mINFO:\e[0m sudo password required\n\nThis script requires elevated permissions for package updates & installations. Please provide your sudo password for these script commands. Sudo permissions are not used for any other purposes.\n"
  251. sudo -v
  252. if [[ $? -ne 0 ]]; then
  253. echo -e "Invalid sudo password.\n"
  254. exit 1
  255. fi
  256. # PID of the current main process
  257. PIDOF=$$
  258. # Run sudo timestamp update on the background and continue the script execution
  259. # Refresh sudo timestamp while the main process is running
  260. function sudo_refresh() {
  261. while [[ $(printf $(ps ax -o pid --no-headers | grep -o ${PIDOF} &> /dev/null)$?) -eq 0 ]]; do
  262. sudo -nv && sleep 2
  263. done
  264. }
  265. sudo_refresh &
  266. }
  267. ###########################################################
  268. function checkInternet() {
  269. if [[ $(echo $(wget --delete-after -q -T 5 github.com -o -)$?) -ne 0 ]]; then
  270. echo -e "\nDNS name resolution failed (GitHub). Please check your network connection settings and try again.\n"
  271. exit 1
  272. fi
  273. rm -f ./index.html.tmp
  274. }
  275. checkInternet
  276. ###########################################################
  277. # Only Debian & Arch based Linux distributions are currently supported
  278. function determineDistroFamily() {
  279. # These are default package managers used by the supported Linux distributions
  280. pkgmgrs=('dpkg' 'pacman')
  281. for pkgmgr in ${pkgmgrs[@]}; do
  282. if [[ $(printf $(which ${pkgmgr} &> /dev/null)$?) -eq 0 ]]; then
  283. pkgmgr_valid=${pkgmgr}
  284. fi
  285. done
  286. case ${pkgmgr_valid} in
  287. dpkg)
  288. distro="debian"
  289. ;;
  290. pacman)
  291. distro="arch"
  292. ;;
  293. default|*)
  294. echo -e "Your Linux distribution is not supported. Aborting.\n"
  295. exit 1
  296. ;;
  297. esac
  298. }
  299. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]; then
  300. echo -e "\n${SCRIPT_TITLE}\n\nBuild identifier:\t${datesuffix}\n"
  301. else
  302. echo ""
  303. fi
  304. if [[ -n ${args[*]} ]]; then
  305. echo -e "Using arguments:\t${args[*]}\n"
  306. fi
  307. determineDistroFamily
  308. INFO_SEP
  309. echo -e "\e[1mNOTE: \e[0mDXVK requires very latest Nvidia/AMD drivers to work.\nMake sure these drivers are available on your Linux distribution.\n\
  310. This script comes with GPU driver installation scripts for Debian-based Linux distributions.\n"
  311. INFO_SEP
  312. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]; then
  313. reqsCheck
  314. sudoQuestion
  315. echo ""
  316. fi
  317. bash -c "cd ${distro} && bash ./updatewine_${distro}.sh ${params[*]}"